various fixes, data subvols changed, mostly handled elsewhere now
[automated-distro-installer] / fai / config / scripts / GRUB_PC / 11-ian
index 629d1bc6a0deaf9a34b91c49b10dd44dda4bad1c..a10efef37e185b42fd8e8a5d40c22b57a4b07a6c 100755 (executable)
@@ -4,44 +4,63 @@ set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
 if [[ $EUID != 0 ]]; then
-    echo "$0: error: expected to be root."
-    exit 1
+  echo "$0: error: expected to be root."
+  exit 1
 fi
 
+if ! type -t fcopy &>/dev/null; then
+  sudo apt-get -y install fai-client
+fi
 
-dir=/q/root/shadow
-if [[ ! -e $dir ]]; then
-    mkdir -p $dir
-    echo "IANNNNNN 111"
-    ls -la $FAI/distro-install-common/shadow
-    mount -o bind $FAI/distro-install-common/shadow $dir
+chroot $FAI_ROOT bash <<'EOFOUTER'
+if getent group systemd-journal >/dev/null; then
+  # makes the journal be saved to disk.
+  mkdir -p /var/log/journal
+  chmod 755 /var/log/journal
 fi
-$FAI/distro-install-common/end
+debconf-set-selections <<EOF
+kexec-tools kexec-tools/load_kexec boolean false
+EOF
+apt-get install -y pxe-kexec
+EOFOUTER
 
-if ifclass STABLE; then
-    fcopy -M /etc/apt/preferences
+# note: # fcopy -i = ignore nonmatching class error, always return 0.
+# this is also done by FABASE/10-misc by default.
+fcopy -ir /root
+if ifclass STABLE_BOOTSTRAP; then
+  fcopy -ri /etc/systemd/system
+  chroot $FAI_ROOT bash <<'EOFOUTER'
+systemctl enable fai_check.service
+EOFOUTER
+  exit 0
 fi
 
-if ifclass DEBIAN; then
-    fcopy -M /etc/apt/preferences.d/unstable
-    fcopy -riM /etc/apt/sources.list.d
+dir=/q/root/shadow
+fai_shadow=$FAI/distro-install-common/shadow
+if [[ ! -e $dir && -e $fai_shadow ]]; then
+  mkdir -p $dir
+  mount -o bind $fai_shadow $dir
 fi
+$FAI/distro-install-common/end
 
 
-# note:
-# fcopy -i = ignore nonmatching class error, always return 0.
+# these get copied in an earlier stage by fai, but leaving it here since
+# I run this as a single post-fai script to update things that have changed.
+fcopy -ri /etc/apt/preferences.d
+fcopy -ri /etc/apt/sources.list.d
+$ROOTCMD apt-get update
+
 
-f=$FAI_ROOT/home/ian/.ssh/authorized_keys
-if [[ ! -L $f || -e $f ]]; then
-    fcopy -r -M /home/ian/.ssh
-else
-    echo "$0: info: $f exists"
-fi
 
 rm -f $FAI_ROOT/etc/apt/sources.list
 
 chroot $FAI_ROOT bash <<'EOF'
 set -eE -o pipefail
+mkdir -p /home/ian/.ssh
+f=/root/.ssh/authorized_keys
+if [[ -e $f ]]; then
+   cp $f /home/ian/.ssh
+fi
 chown -R 1000:1000 /home/ian/.ssh
 chmod -R u=Xrw,og= /home/ian/.ssh
 rm -rf /root/.ssh
@@ -49,8 +68,23 @@ cp -rL /home/ian/.ssh /root
 chown -R root:root /root/.ssh
 chmod 700 /root/.ssh
 
-# default jessie groups + kvm & systemd-journal
-usermod -aG cdrom,floppy,sudo,audio,dip,video,plugdev,netdev,systemd-journal ian
+
+# default jessie groups + kvm, systemd-journal, adm
+usermod -aG adm,cdrom,floppy,sudo,audio,dip,video,plugdev,netdev ian
+
+if getent group systemd-journal >/dev/null; then
+  usermod -aG systemd-journal ian
+fi
+# https://askubuntu.com/questions/33416/how-do-i-disable-the-boot-splash-screen-and-only-show-kernel-and-boot-text-inst
+# it suggests not having plymouth-theme-ubuntu-text, but
+# making it not installed then kills plymouth, then makes
+# the system not boot.
+sed -ri 's/(^ *GRUB_CMDLINE_LINUX.*)quiet splash/\1/' /etc/default/grub
+# on xenial, no grub is displayed at all. fix that.
+# found just by noticing this in the config file, and a
+# warning about it in error.log
+sed -i '/^ *GRUB_HIDDEN_TIMEOUT/d' /etc/default/grub
+update-grub2
 EOF
 
 
@@ -58,7 +92,3 @@ EOF
 for g in plugdev audio video cdrom; do
     $ROOTCMD usermod -a -G $g traci
 done
-
-# makes the journal be saved to disk.
-$ROOTCMD mkdir -p $FAI_ROOT/var/log/journal
-$ROOTCMD chmod 755 $FAI_ROOT/var/log/journal